
#define el_uint32_t                 uint32_t
enum elang_ext_data_type{
    ELANG_EXT_DATA_STR = 0,
    ELANG_EXT_DATA_NIL,
    ELANG_EXT_DATA_FLOAT,
    ELANG_EXT_DATA_LIST,
};
typedef enum elang_ext_data_type elang_ext_data_type_t;

int elang_ext_boot_hook(void** vm);
int elang_ext_exit_hook(void** vm);
int elang_ext_new_state(void** vm);
int elang_ext_register_func(void** vm,char* func_name,int (*cb)(void* vm));
int elang_ext_pop_arg(void** vm,elang_ext_data_type_t *type,unsigned char** data,float* fnum,el_uint32_t* len);
int elang_ext_set_return_var(void** vm,el_uint32_t index);
el_uint32_t elang_ext_new_str_var(void** vm,unsigned char* data,el_uint32_t len);
el_uint32_t elang_ext_new_nil_var(void** vm);
el_uint32_t elang_ext_new_float_var(void** vm,float* value);

int elang_ext_set_code(void** vm,const char* code);
int elang_ext_run(void** vm);
int elang_ext_get_mem_used(void** vm,el_uint32_t* item,el_uint32_t* size);
int elang_ext_add_code(void** vm,const char* code);
int elang_ext_run_auto(void** vm);
