
#include <stdio.h>
#include <stdint.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "elang.h"

/*
 https://manytools.org/hacker-tools/ascii-banner/
 const char* banner = {"           8 8888 8 8888      88  8 8888     ,o888888o.    8 8888888888                d888888o.       ,o888888o.    8 888888888o.    8 8888 8 888888888o 8888888 8888888888 \n\
            8 8888 8 8888      88  8 8888    8888     '88.  8 8888                    .'8888:' '88.    8888     '88.  8 8888    '88.   8 8888 8 8888    '88.     8 8888       \n\
            8 8888 8 8888      88  8 8888 ,8 8888       '8. 8 8888                    8.'8888.   Y8 ,8 8888       '8. 8 8888     '88   8 8888 8 8888     '88     8 8888       \n\
            8 8888 8 8888      88  8 8888 88 8888           8 8888                    '8.'8888.     88 8888           8 8888     ,88   8 8888 8 8888     ,88     8 8888       \n\
            8 8888 8 8888      88  8 8888 88 8888           8 888888888888             '8.'8888.    88 8888           8 8888.   ,88'   8 8888 8 8888.   ,88'     8 8888       \n\
            8 8888 8 8888      88  8 8888 88 8888           8 8888                      '8.'8888.   88 8888           8 888888888P'    8 8888 8 888888888P'      8 8888       \n\
 88.        8 8888 8 8888      88  8 8888 88 8888           8 8888                       '8.'8888.  88 8888           8 8888'8b        8 8888 8 8888             8 8888       \n\
 '88.       8 888' ' 8888     ,8P  8 8888 '8 8888       .8' 8 8888                   8b   '8.'8888. '8 8888       .8' 8 8888 '8b.      8 8888 8 8888             8 8888       \n\
   '88o.    8 88'    8888   ,d8P   8 8888    8888     ,88'  8 8888                   '8b.  ;8.'8888    8888     ,88'  8 8888   '8b.    8 8888 8 8888             8 8888       \n\
     'Y888888 '       'Y88888P'    8 8888     '8888888P'    8 888888888888            'Y8888P ,88P'     '8888888P'    8 8888     '88.  8 8888 8 8888             8 8888       \n"};
*/

// https://manytools.org/hacker-tools/ascii-banner/
// Font: Stop
const char* banner = "\
   _____     _                  _                _            \n\
  (_____)   (_)                | |              (_)      _    \n\
     _ _   _ _  ____ ____       \\ \\   ____  ____ _ ____ | |_  \n\
    | | | | | |/ ___) _  )       \\ \\ / ___)/ ___) |  _ \\|  _) \n\
 ___| | |_| | ( (__( (/ /    _____) | (___| |   | | | | | |__ \n\
(____/ \\____|_|\\____)____)  (______/ \\____)_|   |_| ||_/ \\___)\n\
                                                  |_|         \n\
                                           --juicemail@163.com\n";

// // https://manytools.org/hacker-tools/ascii-banner/
// // Font: Stick Letters
// const char* banner = "\
//              __   ___     __   __   __     __  ___ \n\
//    | |  | | /  ` |__     /__` /  ` |__) | |__)  |  \n\
// \\__/ \\__/ | \\__, |___    .__/ \\__, |  \\ | |     |  \n\
//                                                    \n";

int main(const int argc,const char** argv){
    void* vm;
    void** vm_p = &vm;
    int cur_char;
    FILE *fp;
    el_uint32_t item;
    el_uint32_t size;
    char src_file_buff[10*1024] = {"a=12;"};
    printf("%s",banner);
    printf("Elang boot...\n");
    elang_ext_new_state(vm_p);
    elang_ext_boot_hook(vm);
// {
//     // strcpy(src_file_buff,"a=12;b=123;");
//     strcpy(src_file_buff,"l = {123,\"123\",\"string\"};");
//     elang_ext_set_code(vm_p,src_file_buff);
//     elang_ext_run(vm_p);
//     elang_ext_get_mem_used(vm_p,&item,&size);
//     printf("item: %d size: %d Bytes\n",item,size);
// }
{
    if(argc == 1){
        fp=fopen("hello.txt", "r");
    }else 
    if(argc >= 2){
        printf("\e[31mcode\e[0m: %s\n",*(argv+1));
        fp=fopen(*(argv+1), "r");
    }
    if (fp == NULL){
        printf("file not exist!");
    }else{
        if(fread(src_file_buff,sizeof(src_file_buff),sizeof(char),fp) < 0){
            printf("file is empyty or too Big\n");
            fclose(fp);
            goto _exit_label;
        }
        // printf("src_file_buff: %s\n",src_file_buff);
        cur_char = strlen(src_file_buff);
        // printf("cur_char: %d\n",cur_char);
        elang_ext_set_code(vm_p,src_file_buff);
        // printf("elang_ext_set_code OK\n");
        elang_ext_run(vm_p);
        // printf("elang_ext_run OK\n");
        elang_ext_get_mem_used(vm_p,&item,&size);
        printf("\e[34melang_ext_run OK\e[0m\n");
        printf("\e[31mitem: %d size: %d Bytes\e[0m\n",item,size);
        // goto _exit_label;
    }
}

_exit_label:
    fclose(fp);
    elang_ext_exit_hook(vm);
}